#
# FreeType 2 vcft driver configuration rules
#


# Copyright (C) 2002 by
# Koffman Huang
#


# vcft driver directory
#
VCFT_DIR  := $(SRC_DIR)/vcft
VCFT_DIR_ := $(VCFT_DIR)$(SEP)

# compilation flags for the driver
#
VCFT_COMPILE := $(FT_COMPILE) $I$(subst /,$(COMPILER_SEP),$(VCFT_DIR))


# vcft driver sources (i.e., C files)
#
VCFT_DRV_SRC := $(VCFT_DIR_)/val-gdl.c $(VCFT_DIR_)/dout.c $(VCFT_DIR_)/sorter.c \
                $(VCFT_DIR_)/val-crv.c $(VCFT_DIR_)/dcrva7.c $(VCFT_DIR_)/dnewop.c \
                $(VCFT_DIR_)/dspltat.c $(VCFT_DIR_)/ddowncv.c $(VCFT_DIR_)/gdlpro.c \
                $(VCFT_DIR_)/vcfget.c $(VCFT_DIR_)/vcflib.c $(VCFT_DIR_)/vcdriver.c \
                $(VCFT_DIR_)/vcobjs.c

# vcft driver headers
#
VCFT_DRV_H := $(VCFT_DIR)/typedef.h \
              $(VCFT_DIR)/val-crv.h \
              $(VCFT_DIR)/val-gdl.h \
              $(VCFT_DIR)/alldef.h \
              $(VCFT_DIR)/com_def.h \
              $(VCFT_DIR)/vcdriver.h \
              $(VCFT_DIR)/vcerrors.h \
              $(VCFT_DIR)/vcobjs.h

# vcft driver object(s)
#
#   VCFT_DRV_OBJ_M is used during `multi' builds
#   VCFT_DRV_OBJ_S is used during `single' builds
#
VCFT_DRV_OBJ_M := $(VCFT_DRV_SRC:$(VCFT_DIR_)/%.c=$(OBJ_DIR)/%.$O)
VCFT_DRV_OBJ_S := $(OBJ_DIR)/vcft.$O

# vcft driver source file for single build
#
VCFT_DRV_SRC_S := 


# vcft driver - single object
#
$(VCFT_DRV_OBJ_S): $(VCFT_DRV_SRC_S) $(VCFT_DRV_SRC) $(FREETYPE_H) $(VCFT_DRV_H)


# vcft driver - multiple objects
#
$(VCFT_DRV_SRC):


$(OBJ_DIR)/%.$O: $(VCFT_DIR)/%.c $(FREETYPE_H) $(VCFT_DRV_H) $(VCFT_DRV_SRC)
	$(VCFT_COMPILE) $T$@ $<


# update main driver object lists
#
DRV_OBJS_S += $(VCFT_DRV_OBJ_S)
DRV_OBJS_M += $(VCFT_DRV_OBJ_M)


# EOF