/***************************************************************************/
/*                                                                         */
/*  vctypes.h                                                              */
/*                                                                         */
/*    Basic VCFT type definitions and interface (specification             */
/*    only).                                                               */
/*                                                                         */
/*  Copyright 2002 by                                                      */
/*  Arphic Technology co.,Ltd                                              */
/*  Coding by Koffman Huang 2003.10.28                                     */
/*                                                                         */
/***************************************************************************/

#ifndef __VCFTTYPES_H__
#define __VCFTTYPES_H__

/* define VCFT */
#define MAX_VCFT_FONTS 12
#define VCFT_WORKING_BUFFER 16*1024

#define BIG5     0
#define SJIS     1
#define ASCII    2
#define GB2312   3
#define UNICODE  4

#include<ft2build.h>
#include FT_INTERNAL_OBJECTS_H

FT_BEGIN_HEADER

  typedef struct  VCFT_FaceRec_
  {
    FT_FaceRec    root;
    FT_Stream     VCFStr;                    /* file stream */
    FT_Short      FaceNum;                   /* the face which order of this font */
    FT_Long       Address[MAX_VCFT_FONTS];   /* all face address of this font */
    FT_Short      Font_ID[MAX_VCFT_FONTS];   /* all face id of this font */
    FT_Long       NumGlyphs[MAX_VCFT_FONTS]; /* all face of number of glyphs of this font */
    FT_Short      Encoding;                  /* the face which encoding */
    FT_Bool       HelfChar;                  /* for english or sjis one byte area */
  } VCFT_FaceRec;

  typedef struct VCFT_FaceRec_ *VCFT_Face;

FT_END_HEADER



#endif /* __VCFTTYPES_H__ */

/* END */
